"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/components/Checkbox/index.tsx
var Checkbox_exports = {};
__export(Checkbox_exports, {
  GroupCheckbox: () => GroupCheckbox,
  default: () => Checkbox
});
module.exports = __toCommonJS(Checkbox_exports);

// src/components/GroupCheckbox/index.tsx
var import_react = require("react");
var import_jsx_runtime = require("react/jsx-runtime");
function GroupCheckbox(props) {
  const {
    list = [],
    hasSearch = false,
    setSelectedItems,
    parentClassName = "",
    checkboxClassName = "",
    checkboxFilledClassName = "",
    labelClassName = "",
    searchOption = { label: "", className: "", disabled: false },
    selectType = "single",
    customIcon = null
  } = props;
  const [mainData, setMainData] = (0, import_react.useState)(list);
  const [showData, setShowData] = (0, import_react.useState)([]);
  const [search, setSearch] = (0, import_react.useState)("");
  (0, import_react.useEffect)(() => {
    setShowData(mainData);
    let selectedFilter = mainData.filter((item) => item.checked);
    if (selectType == "single") {
      setSelectedItems(selectedFilter[0]);
    } else if (selectType == "multiple") {
      setSelectedItems(selectedFilter);
    }
  }, [mainData]);
  (0, import_react.useEffect)(() => {
    let newList = mainData.filter((item) => item.name.includes(search));
    if (!newList) return;
    setShowData(newList);
  }, [search, mainData]);
  function checkBoxHandler(e) {
    let updateList;
    if (selectType == "multiple") {
      updateList = mainData.map((item) => {
        if (item.name == e.target.id) {
          if (item.checked) {
            item.checked = false;
          } else {
            item.checked = true;
          }
        }
        return item;
      });
    } else if (selectType == "single") {
      updateList = mainData.map((item) => {
        if (item.name == e.target.id) {
          if (item.checked) {
            item.checked = false;
          } else {
            item.checked = true;
          }
        } else {
          if (item.checked) {
            item.checked = false;
          }
        }
        return item;
      });
    }
    if (!updateList) return;
    setMainData(updateList);
  }
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: parentClassName, children: [
    hasSearch && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "input",
      {
        type: "text",
        placeholder: searchOption.label,
        disabled: searchOption.disabled,
        className: searchOption.className,
        onChange: (e) => setSearch(e.target.value)
      }
    ),
    showData.length ? showData.map((item, index) => {
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        Checkbox,
        {
          disabled: item.disabled,
          parentClassName: checkboxFilledClassName,
          labelClassName,
          inputClassName: checkboxClassName,
          name: item.name || "",
          checked: item.checked,
          label: item.label || item.name,
          onChange: checkBoxHandler,
          customIcon
        },
        index
      );
    }) : hasSearch ? searchOption.emptyComponent || /* @__PURE__ */ (0, import_jsx_runtime.jsx)("p", { children: "Not Found!" }) : null
  ] });
}

// src/components/Checkbox/index.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
function Checkbox({
  name,
  onChange,
  id,
  label,
  checked = false,
  disabled = false,
  parentClassName,
  labelClassName,
  inputClassName,
  customIcon = null
}) {
  const customCheckboxStyle = {
    backgroundImage: `url(${checked ? customIcon?.checked : customIcon?.unChecked})`,
    backgroundSize: "cover",
    width: customIcon?.size || 16,
    height: customIcon?.size || 16
  };
  const inputContainerStyle = {
    width: customIcon?.size || 16,
    height: customIcon?.size || 16
  };
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("label", { className: parentClassName, children: [
    customIcon ? /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { style: inputContainerStyle, className: "cursor-pointer", children: [
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
        "input",
        {
          className: ` absolute z-10 visible opacity-0`,
          type: "checkbox",
          id: name,
          "data-id": id || name,
          name,
          checked,
          onChange,
          disabled
        }
      ),
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
        "label",
        {
          htmlFor: name,
          style: customCheckboxStyle,
          className: "block bg-cover cursor-pointer"
        }
      )
    ] }) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
      "input",
      {
        className: inputClassName,
        type: "checkbox",
        id: name,
        "data-id": id || name,
        name,
        checked,
        onChange,
        disabled
      }
    ),
    label ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("label", { className: labelClassName, htmlFor: name, children: label }) : null
  ] });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  GroupCheckbox
});
